release:
  stage: release
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule" && $IS_RELEASE == "false"
      when: manual
      allow_failure: true
    - if: $CI_PIPELINE_SOURCE == "schedule" && $IS_RELEASE == "true"
      when: on_success
  image: node:14-alpine
  before_script:
    - apk add --update curl jq
    - apk add --update openssh-client git
  script:
    - eval $(ssh-agent -s)
    - echo "$DEPLOY_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - git config user.email "gitlab-runner@gitlab.com"
    - git config user.name "Gitlab Runner"
    - export CI_PUSH_REPO=$(echo "$CI_REPOSITORY_URL" | sed -e "s|.*@\(.*\)|git@\1|" -e "s|/|:/|" )
    - git remote set-url --push origin "ssh://${CI_PUSH_REPO}"
    - git reset --hard
    - git clean -fd
    - git checkout dev
    - git pull origin dev
    - npx standard-version --no-verify
    - PACKAGE_VERSION=$(node -p "require('./package.json').version")
    - VERSION_BADGE_ID=$(curl --header "PRIVATE-TOKEN:${GITLAB_API_TOKEN}" https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/badges | jq -c 'map(select(.name | contains("version")))[0].id')
    - curl --request PUT --header "PRIVATE-TOKEN:${GITLAB_API_TOKEN}" --data "image_url=https://img.shields.io/badge/version-${PACKAGE_VERSION}-blue" https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/badges/${VERSION_BADGE_ID}
    - git push --follow-tags origin dev
    - git checkout main
    - git pull origin main
    - git merge dev
    - 'git commit --amend -m "chore(release): ${PACKAGE_VERSION}"'
    - git push origin main
